function ParseError (message, pos, input) {
    var error = `Error: ${message}`;
    // If we have the input and a position, make the error a bit fancier
    if (pos !== undefined && input !== undefined) {
        error += ` at position ${pos}: \``;

        // Insert a combining underscore at the correct position
        input = `${input.slice(0, pos)}\u21B1${input.slice(pos)}`;

        // Extract some context from the input and add it to the error
        var begin = Math.max(0, pos - 15);
        var end = pos + 15;
        error += `${input.slice(begin, end)}\``;
    }

    this.message = error;
}
ParseError.prototype = Object.create(Error.prototype);
ParseError.prototype.constructor = ParseError;

module.exports = ParseError;
